]> git.pld-linux.org Git - packages/rpm.git/blob - rpm.macros
- fix file counting, print status only if something is to be done
[packages/rpm.git] / rpm.macros
1 # $Revision$, $Date$
2 # PLD Linux rpm macros
3
4 %epoch          0
5 %x8664          x86_64 amd64 ia32e
6
7 # kernel compiler
8 %kgcc           %{__cc}
9 %kgcc_package   gcc
10
11 # Build system path macros.
12 #
13 %__autoconf             autoconf %{?debug:-Wall}
14 %__automake             automake -a -c -f --foreign
15 %__autopoint            autopoint --force
16
17 %__gettextize { \
18         if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
19                 gettextize --copy --force --no-changelog; \
20         else \
21                 gettextize --copy --force --no-changelog --intl; \
22         fi; \
23         if [ ! -f po/Makevars ]; then \
24                 cp -f po/Makevars{.template,}; \
25         fi; \
26 }
27
28 %__glib_gettextize      glib-gettextize --copy --force
29 %__gnome_doc_common     gnome-doc-common --copy
30 %__gnome_doc_prepare    gnome-doc-prepare --copy --force
31 %__gtkdocize            gtkdocize --copy
32 %__intltoolize          intltoolize --copy --force
33 %__libtoolize           libtoolize --copy --force
34
35 #       The number of cvs changelog entries kept when building package.
36 %_buildchangelogtruncate 20
37
38 %dependencytracking     %{nil}
39
40 #       Relations between package names that cause dependency loops
41 #       with legacy packages that cannot be fixed. Relations are
42 #       specified as
43 #               p>q
44 #       where package p has a Requires: on something that package q Provides:
45 #
46 # XXX   Note: that there cannot be any whitespace within the string "p>q",
47 #       and that both p and q are package names (i.e. no version/release).
48 %_dependency_whiteout   %{nil}
49
50 %_smp_mflags %([ -z "$RPM_BUILD_NCPUS" ] \\\
51         && RPM_BUILD_NCPUS="`/usr/bin/getconf _NPROCESSORS_ONLN`"; \\\
52         [ "$RPM_BUILD_NCPUS" -gt 1 ] && echo "-j$RPM_BUILD_NCPUS")
53
54 #-----------------------------------------------------------------
55 #
56 # (re)definition of %{rpm*flags} with %filterout_* support
57 # BuildRequires:        awk
58 # BuildRequires:        rpmbuild(macros) >= 1.315
59 #
60 # Flags specified in %filterout_* are removed from %rpm*flags, exactly:
61 # %rpmcflags    = %optflags - %filterout - %filterout_c   - %filterout_ld
62 # %rpmcxxflags  = %optflags - %filterout - %filterout_cxx - %filterout_ld
63 # %rpmldflags   = %optldflags - %filterout_ld
64 #
65 # Regular expressions are supported, but to avoid some character be treated
66 # as regular expression it must be escaped twice.
67
68 %filter_out                                             \
69         for (i = 1; i in I; i++) {      A=0;    \
70                 for (f in F) {                          \
71                         if (I[i] ~ "^" F[f] "$") A=1;   \
72                 };                                                      \
73                 if (!A) printf(I[i] FS);        \
74         }
75
76 %rpmcflags %(awk 'BEGIN {
77         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
78         split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
79         %{filter_out}
80 }')
81
82 %rpmcxxflags %(awk 'BEGIN {
83         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
84         split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
85         %{filter_out}
86 }')
87
88 %rpmldflags %(awk 'BEGIN {
89         split("%{?optldflags}",I);
90         split("%{?filterout_ld}",F)
91         %{filter_out}
92 }')
93
94 # rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
95 # but, don't use it, better use gcc as linker
96 %ld_rpmldflags %(awk 'BEGIN {
97         split("%{rpmldflags}",F);
98         for (f in F) {
99                 s = F[f];
100                 if (s ~ /^-Wl,/) {
101                         s = substr(s,5);
102                         gsub(/,/," ",s);
103                 };
104                 printf(s FS);
105         };
106 }')
107
108 #-----------------------------------------------------------------
109 %configure2_13 { \
110  if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
111  LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
112  CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
113  CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
114  FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
115  FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
116  CPPFLAGS="${CPPFLAGS:-}" ; export CPPFLAGS ; \
117  %{?__cc:CC="%{__cc}" ; export CC ; } \
118  %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
119  %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
120         --host=%{_target_platform} \
121         --prefix=%{_prefix} \
122         --exec-prefix=%{_exec_prefix} \
123         --bindir=%{_bindir} \
124         --sbindir=%{_sbindir} \
125         --sysconfdir=%{_sysconfdir} \
126         --datadir=%{_datadir} \
127         --includedir=%{_includedir} \
128         --libdir=%{_libdir} \
129         --libexecdir=%{_libexecdir} \
130         --localstatedir=%{_localstatedir} \
131         --sharedstatedir=%{_sharedstatedir} \
132         --mandir=%{_mandir} \
133         --infodir=%{_infodir} \
134         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
135         %{dependencytracking} \
136 }
137
138 # override __cmake to add -j4 in your ~/.rpmmacros for parallel make
139 %__cmake        /usr/bin/cmake
140 %cmake { \
141 CC="%{__cc}" \
142 CXX="%{__cxx}" \
143 CFLAGS="%{rpmcflags}" \
144 CXXFLAGS="%{rpmcxxflags}" \
145 %{__cmake} \
146 }
147
148 # override __scons to add -j4 in your ~/.rpmmacros for parallel make
149 %__scons        /usr/bin/scons
150 %scons { \
151 %{__scons} \
152         LDFLAGS="${LDFLAGS:-%rpmldflags}" \
153         CFLAGS="${CFLAGS:-%rpmcflags}" \
154         CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
155         FFLAGS="${FFLAGS:-%rpmcflags}" \
156         CPPFLAGS="${CPPFLAGS:-}" \
157         %{?__cc:CC="%{__cc}"} \
158         %{?__cxx:CXX="%{__cxx}"} \
159         libsuffix=%{_lib} \
160         prefix=%{_prefix} \
161 }
162
163 # waf. see waf.spec
164 # override __waf to add -j4 in your ~/.rpmmacros for parallel make
165 %__waf  /usr/bin/waf
166 %waf { \
167 CC="%{__cc}" \
168 CXX="%{__cxx}" \
169 CPP="%{__cpp}" \
170 CFLAGS="%{rpmcflags}" \
171 CXXFLAGS="%{rpmcxxflags}" \
172 %{__waf} \
173 }
174
175 #----------------------------------------------------------------
176 %global configure_cache 0
177 %configure_cache_file   %{buildroot}.configure.cache
178
179 %configure {./configure \
180         LDFLAGS="${LDFLAGS:-%rpmldflags}" \
181         CFLAGS="${CFLAGS:-%rpmcflags}" \
182         CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
183         FFLAGS="${FFLAGS:-%rpmcflags}" \
184         FCFLAGS="${FCFLAGS:-%rpmcflags}" \
185         CPPFLAGS="${CPPFLAGS:-}" \
186         %{?__cc:CC="%{__cc}"} \
187         %{?__cxx:CXX="%{__cxx}"} \
188         --host=%{_target_platform} \
189         --build=%{_target_platform} \
190         --prefix=%{_prefix} \
191         --exec-prefix=%{_exec_prefix} \
192         --bindir=%{_bindir} \
193         --sbindir=%{_sbindir} \
194         --sysconfdir=%{_sysconfdir} \
195         --datadir=%{_datadir} \
196         --includedir=%{_includedir} \
197         --libdir=%{_libdir} \
198         --libexecdir=%{_libexecdir} \
199         --localstatedir=%{_localstatedir} \
200         --sharedstatedir=%{_sharedstatedir} \
201         --mandir=%{_mandir} \
202         --infodir=%{_infodir} \
203         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
204         %{dependencytracking} \
205         %{?configure_cache:--cache-file=%{configure_cache_file:-%{buildroot}.configure.cache}} \
206 }
207
208 # Location of autoconf macros
209 %_aclocaldir    %(aclocal --print-ac-dir)
210
211 # Location of omf files
212 %_omf_dest_dir  %(scrollkeeper-config --omfdir)
213
214 # Location of pkgconfig files
215 %_pkgconfigdir  /usr/%{_lib}/pkgconfig
216
217 # Location of desktop files
218 %_desktopdir    /usr/share/applications
219 %_applnkdir     ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
220
221 # Location of pixmaps for applnk/desktop files
222 %_pixmapsdir    /usr/share/pixmaps
223
224 # Location of themable icons for applnk/desktop files
225 %_iconsdir      /usr/share/icons
226
227 # Location of fonts directories
228 %_fontsdir      /usr/share/fonts
229
230 # Location of Gtk and associated libraries documentation
231 %_gtkdocdir     %{_defaultdocdir}/gtk-doc/html
232
233 # Location of KDE documentation
234 %_kdedocdir     %{_defaultdocdir}/kde/HTML
235
236 # unsermake script
237 %__unsermake /usr/share/unsermake/unsermake
238
239 # Current date
240 %date           %(LC_ALL="C" date +"%a %b %d %Y")
241
242 # tmp directory
243 %tmpdir         %(echo "${TMPDIR:-/tmp}")
244
245 # Example files, programs, scripts...
246 %_examplesdir   /usr/src/examples
247
248 # Alternative kernel type/version
249 %_alt_kernel    %{nil}%{?alt_kernel:-%{?alt_kernel}}
250
251 # The directory holding Linux kernel sources
252 %_kernelsrcdir  /usr/src/linux%{_alt_kernel}
253
254 # If non-empty "debug" macro defined, add "dbg" suffix to release number
255 %_rpmfilename           %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
256
257 # Requires name = version-release
258 %requires_releq()               %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %%{name} = %%{epoch}:%%{version}-%%{release}\\n' | sed -e 's/ (none):/ /' | grep -v "is not")
259
260 %releq_kernel()                 %((LC_ALL="C" rpm -qf --qf '%%{name} = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h 2>/dev/null || echo ERROR) | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
261 %releq_kernel_up()              %((LC_ALL="C" rpm -qf --qf '%%{name}-up = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h 2>/dev/null || echo ERROR) | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
262 %releq_kernel_smp()             %((LC_ALL="C" rpm -qf --qf '%%{name}-smp = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h 2>/dev/null || echo ERROR) | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
263 %requires_releq_kernel(s:)              Requires%{-s:(%{-s*})}: %releq_kernel
264 %requires_releq_kernel_up(s:)   Requires%{-s:(%{-s*})}: %releq_kernel_up
265 %requires_releq_kernel_smp(s:)  Requires%{-s:(%{-s*})}: %releq_kernel_smp
266
267 %requires_eq()          %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %%{name} = %%{epoch}:%%{version}\\n' | sed -e 's/ (none):/ /' -e 's/ 0:/ /' | grep -v "is not")
268 %requires_eq_to() %(LC_ALL="C" rpm -q --qf 'Requires: %1 = %%{epoch}:%%{version}\\n' %2 | sed -e 's/ (none):/ /' | grep -v "is not")
269
270 %apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)
271
272 # kernel version-release handling
273 %__kernel_ver   %( VER_H=%{_kernelsrcdir}/include/linux/utsrelease.h; [ -f $VER_H ] || VER_H=%{_kernelsrcdir}/include/linux/version.h; [ -f $VER_H ] && (grep UTS_RELEASE $VER_H 2>/dev/null | head -n 1 | cut -d'"' -f2) || (awk '/^VERSION/ { ver = $0; gsub(/VERSION.*=/, NIL, ver); } /^PATCHLEVEL/ { plev = $0; gsub(/PATCHLEVEL.*=/, NIL, plev); } /^SUBLEVEL/ { slev = $0; gsub(/SUBLEVEL.*=/, NIL, slev); } /^EXTRAVERSION/ { ever = $0; gsub(/EXTRAVERSION.*=/, NIL, ever); gsub(/ /, NIL, ever); } END { printf("%d.%d.%d%s", ver, plev, slev, ever); }' %{_kernelsrcdir}/Makefile 2> /dev/null))
274 %__kernel_rel   %(LC_ALL="C" rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{RELEASE}" | grep -v "is not")
275 %__kernel_rpmvr %(LC_ALL="C" rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{VERSION}-%{RELEASE}" | grep -v "is not")
276 %_kernel_ver    %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}
277 %_kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')
278
279 # sgml macros
280 %xmlcat_add()           /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
281 %xmlcat_del()           /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
282 %xmlcat_add_rewrite     /usr/bin/xmlcatalog --noout --add rewriteSystem
283 %xmlcat_create()        /usr/bin/xmlcatalog --noout --create %1 ;
284 %sgmlcat_add()          /usr/bin/install-catalog --add %1 %2 > /dev/null ;
285 %sgmlcat_del()          /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
286 %docbook_sgmlcat_fix() { for l in \
287 '' \
288 '  -- default decl --' \
289 'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
290 '  -- hacks for opensp --' \
291 'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
292 'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd"                  "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
293 '' \
294 ; do echo $l; done >> %1 \
295 }
296
297 # vim - "
298
299 # minimum file size needed for compressed documents.
300 # just smaller files than this get larger when compressed.
301 # some stats:
302 # - 0 byte file compressed was 25 bytes .gz
303 # - 39 byte file was compressed as 57
304 # - with test/test.spec@man 158 byte file was compressed also 158
305 %_min_compress_bytes    159
306
307 #-----------------------------------------------------------------
308 # find and gzip all files in %{_mandir} and %{infodir}
309 #
310 # Requires: xargs, find
311 #
312 #%no_install_post_compress_docs 1
313 %__spec_install_post_compress_docs { \
314 %{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
315         for i in /usr/share/man /usr/X11R6/man; do \
316                 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
317                         echo "Compress man pages: $i"; \
318                         find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
319                         find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
320                         find $RPM_BUILD_ROOT$i -type l | while read a; do \
321                                 m=$(readlink $a); \
322                                 rm -f $a; \
323                                 echo .so ${m##*/} > $a; \
324                                 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: ${m##*/}"; \
325                         done; \
326                         find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
327                 fi; \
328         done; \
329         if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
330                 echo "Compress info pages: %{_infodir}"; \
331                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
332                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
333                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
334         fi; \
335 }; __spec_install_post_compress_docs } }
336
337 #-----------------------------------------------------------------
338 # Strip executable binaries and shared object files
339 #
340 # Requires: find, awk, strip, cut, xargs
341 #
342 # Special macros which affect this process:
343 #%no_install_post_strip 1               # disable stripping at all
344 #%_noautostrip                  regexp  # exclude files matching (anchored!) regex from stripping
345 #%_autostripall                 regexp  # strip files matching (anchored!) regex using plain strip
346 #%_autostripunneeded    regexp  # strip files matching (anchored!) regex using strip --strip-unneeded
347 #%_autostripdebug               regexp  # strip files matching (anchored!) regex using strip --strip-debug
348 #
349 %__spec_install_post_strip {%{!?debug: \
350 %{!?no_install_post_strip:__spec_install_post_strip() { \
351 if [ -d "$RPM_BUILD_ROOT" ]; then \
352         if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
353                 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
354                 if [ "$modulelist" ]; then \
355                         modulecount=$(echo "$modulelist" | wc -l); \
356                         printf "Stripping %d kernel modules..." $modulecount; \
357                         echo "$modulelist" | xargs -l512 chmod u+w; \
358                         echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
359                         echo "DONE"; \
360                 fi; \
361         fi; \
362         filelist=`find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}`; \
363         if [ -n "$filelist" ]; then \
364                 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
365                 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
366                 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
367                 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
368                 if [ -n "$elfexelist" ]; then \
369                         printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
370                         chmod u+w $elfexelist; \
371                         %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
372                         echo "DONE"; \
373                 fi; \
374                 if [ -n "$elfsharedlist" ]; then \
375                         printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
376                         chmod u+w $elfsharedlist; \
377                         %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
378                         echo "DONE"; \
379                 fi; \
380                 if [ -n "$archiveslist" ]; then \
381                         printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
382                         chmod u+w $archiveslist; \
383                         %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
384                         echo "DONE"; \
385                 fi; \
386         fi; \
387     filelist_all=%{?_autostripall:`find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}"`}; \
388     filelist_unneeded=%{?_autostripunneeded:`find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}"`}; \
389     filelist_debug=%{?_autostripdebug:`find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}"`}; \
390         if [ -n "$filelist_all" ]; then \
391                 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
392                 chmod u+w $filelist_all; \
393                 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
394                 echo "DONE"; \
395         fi; \
396         if [ -n "$filelist_unneeded" ]; then \
397                 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
398                 chmod u+w $filelist_unneeded; \
399                 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
400                 echo "DONE"; \
401         fi; \
402         if [ -n "$filelist_debug" ]; then \
403                 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
404                 chmod u+w $filelist_debug; \
405                 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
406                 echo "DONE"; \
407         fi; \
408 fi; }; __spec_install_post_strip } } }
409
410 #-----------------------------------------------------------------
411 # remove all RPATH from executable binaries and shared object files
412 #
413 # Requires: find, awk, cut, xargs, chrpath, uname
414 #
415 # Special macros which affect this process
416 #%no_install_post_chrpath       1       # disable chrpath at all
417 #%_noautochrpath        regex           # exclude files matching (anchored!) regex from chrpath
418 #
419 %__spec_install_post_chrpath {%{!?debug: \
420 %{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
421 if [ -d "$RPM_BUILD_ROOT" ]; then \
422         files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
423         if [ -n "$files" ]; then \
424                 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
425         fi; \
426         if [ -n "$objs" ]; then \
427                 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
428                 echo "$objs" | \
429                 while read file; do \
430                         rpath= ; \
431                         chmod u+w "$file"; \
432                         for dir in `chrpath -l "$file" | \
433                                         awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'` ; do \
434                                         case $dir in \
435                                         /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
436                                                 echo "remove-rpath: $dir in $file"; \
437                                                 ;; \
438                                         * ) \
439                                                 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
440                                                 else rpath="$rpath:$dir" ; fi ; \
441                                                 ;; \
442                                         esac ; \
443                         done ; \
444                         if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
445                         else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
446                 done; \
447         fi; \
448 fi; }; __spec_install_post_chrpath } } }
449
450 #-----------------------------------------------------------------
451 # Find and gzip all kernel modules
452 #
453 # Requires: find
454 #
455 #%no_install_post_compress_modules      1
456 %__spec_install_post_compress_modules { \
457 %{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
458         if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
459                 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
460                 if [ "$q" ]; then \
461                         printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
462                         echo "$q" | xargs -r %{__gzip} -9nf; \
463                         echo "DONE"; \
464                         find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
465                         while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
466                 fi; \
467         fi; \
468 }; __spec_install_post_compress_modules } }
469
470 # Remove common Perl files we don't package
471 %__spec_install_post_perl_clean {\
472 %{!?no_install_post_perl_clean: \
473 %{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
474 } }
475
476 #-----------------------------------------------------------------
477 # Update GConf2 schemas
478 #
479 # Requires: GConf2
480 #
481 %gconf_schema_install() \
482         umask 022; \
483         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null \
484         %{nil}
485
486 %gconf_schema_uninstall() \
487 if [ $1 = 0 ]; then \
488         umask 022; \
489         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
490 fi \
491 %{nil}
492
493 #-----------------------------------------------------------------
494 # Update desktop MIME database
495 # requires: desktop-file-utils
496 #
497 %update_desktop_database_post() {{ \
498         umask 022; \
499         /usr/bin/update-desktop-database -q; \
500 }} \
501 %{nil}
502
503 %update_desktop_database_postun() {{ \
504 if [ $1 = 0 ]; then \
505         umask 022; \
506         /usr/bin/update-desktop-database -q; \
507 fi \
508 }} \
509 %{nil}
510
511 #-----------------------------------------------------------------
512 # Update shared MIME info database
513 # requires: shared-mime-info
514 #
515 %update_mime_database() {{ \
516         umask 022; \
517         /usr/bin/update-mime-database %{_datadir}/mime; \
518 }} \
519 %{nil}
520
521 #-----------------------------------------------------------------
522 # Update icon cache
523 # requires: gtk+
524 #
525 %update_icon_cache() {{ \
526         umask 022; \
527         /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
528 }} \
529 %{nil}
530
531 #-----------------------------------------------------------------
532 # Update scrollkeeper database
533 # requires: scrollkeeper
534 #
535 %scrollkeeper_update_post() \
536         /usr/bin/scrollkeeper-update -q; \
537         %{nil}
538
539 %scrollkeeper_update_postun() \
540 if [ $1 = 0 ]; then \
541         /usr/bin/scrollkeeper-update -q; \
542 fi \
543 %{nil}
544
545 #-----------------------------------------------------------------
546 # post %install sequence:
547 # - autodeps exceptions
548 # - compress all man and info pages,
549 # - strip all ELF executables and ELF shared objects if not %debug.
550 # - compress kernel modules if any
551
552 ###################################################################
553 # Requires/Provides automation
554 # exceptions system by Jacek Konieczny <jajcus@pld.org.pl>
555 #
556 %__noautoreqfiles       %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
557 %__noautoprovfiles      %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
558 %__noautoreq            %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
559 %__noautoreqdep         %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
560 %__noautoprov           %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
561 #%_noautocompressdoc    %{nil}
562 #
563 %_missing_doc_files_terminate_build     1%{nil}
564 %_unpackaged_files_terminate_build      %{nil}
565 # (X)emacs support
566 %___emacs_lispdir_helper  -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
567 %_emacs_lispdir %(emacs %___emacs_lispdir_helper)
568 %_xemacs_lispdir %(xemacs %___emacs_lispdir_helper)
569
570 %__php_provides %{nil}
571 %__php_requires %{nil}
572 %__perl_provides %{nil}
573 %__perl_requires %{nil}
574 %__mono_provides %{nil}
575 %__mono_requires %{nil}
576
577 # Perl specific macro definitions.
578 %perl_privlib           %(eval "`%{__perl} -V:installprivlib`"; echo $installprivlib)
579 %perl_archlib           %(eval "`%{__perl} -V:installarchlib`"; echo $installarchlib)
580 %perl_vendorlib         %(eval "`%{__perl} -V:installvendorlib`"; echo $installvendorlib)
581 %perl_vendorarch        %(eval "`%{__perl} -V:installvendorarch`"; echo $installvendorarch)
582 %perl_sitelib           %(eval "`%{__perl} -V:installsitelib`"; echo $installsitelib)
583 %perl_sitearch          %(eval "`%{__perl} -V:installsitearch`"; echo $installsitearch)
584
585 # Ruby
586 %ruby_archdir           %(ruby -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)
587 %ruby_ridir                     %(ruby -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)
588 %ruby_rubylibdir        %(ruby -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)
589 %ruby_vendorarchdir     %(ruby -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)
590 %ruby_vendorlibdir      %(ruby -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)
591 %ruby_sitearchdir       %(ruby -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)
592 %ruby_sitelibdir        %(ruby -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)
593 %ruby_version           %(ruby -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)
594 %ruby_ver_requires_eq   Requires:       ruby(ver) = %ruby_version
595 %ruby_mod_ver_requires_eq       Requires:       ruby-modules(ver) = %ruby_version
596
597 %php_pear_dir           /usr/share/pear
598 %php_extensiondir       %(php-config --extension-dir 2>/dev/null || echo ERROR)
599 %php_sysconfdir         %(php-config --sysconfdir 2>/dev/null || echo ERROR)
600 %php_includedir         %(php-config --include-dir 2>/dev/null || echo ERROR)
601
602 # extract php/zend api versions
603 %php_major_version              %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)
604 %php_api_version                %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)
605 %php_pdo_api_version    %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)
606 %php_debug                              %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)
607 %zend_module_api                %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)
608 %zend_extension_api             %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)
609 %zend_zts                               %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})
610
611 # helper macro
612 %__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
613
614 # macros for public use
615 # for php extensions (php-pecl)
616 %requires_php_extension %{__php_api_requires modules_api php_api_version} \
617 %{__php_api_requires zend_module_api} \
618 %{__php_api_requires -v %php_major_version debug php_debug} \
619 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
620
621 # for zend extensions
622 %requires_zend_extension %{__php_api_requires zend_module_api} \
623 %{__php_api_requires zend_extension_api} \
624 %{__php_api_requires -v %php_major_version debug php_debug} \
625 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
626
627 # for php pdo modules (php-pecl-PDO_*)
628 %requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
629
630 # for using PHP post scripts. for PHP >= 5.0
631 %php_webserver_restart \
632 [ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
633 [ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
634 if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
635         PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
636         if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
637                 %service -q php-fcgi restart \
638         fi \
639 fi \
640 %{nil}
641
642 # for using php post scripts. for PHP >= 4.0 && PHP < 5.0
643 %php4_webserver_restart \
644 [ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
645 [ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
646 if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
647         PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
648         if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
649                 %service -q php-fcgi restart \
650         fi \
651 fi \
652 %{nil}
653
654
655 # X.org helper macros
656 %__xorg_abi_requires() Requires: xorg-xserver-server(%{expand:%1}-abi) = %{expand:%{%{!?2:%{1}}%{?2}}}
657 #
658 %xorg_xserver_ansic_abi         %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)
659 %xorg_xserver_extension_abi     %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)
660 %xorg_xserver_font_abi          %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)
661 %xorg_xserver_videodrv_abi      %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)
662 %xorg_xserver_xinput_abi        %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)
663
664 %requires_xorg_xserver_extension %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
665 %{__xorg_abi_requires extension xorg_xserver_extension_abi}
666 %requires_xorg_xserver_xinput %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
667 %{__xorg_abi_requires xinput xorg_xserver_xinput_abi}
668 %requires_xorg_xserver_font %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
669 %{__xorg_abi_requires font xorg_xserver_font_abi}
670 %requires_xorg_xserver_videodrv %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
671 %{__xorg_abi_requires videodrv xorg_xserver_videodrv_abi}
672
673 # Python specific macro definitions.
674 # python main version
675 %py_ver                 %(python -c "import sys; print sys.version[:3]")
676
677 # directories
678 %py_prefix              %(python -c "import sys; print sys.prefix")
679 %py_libdir              %{py_prefix}/%{_lib}/python%{py_ver}
680 %py_scriptdir   %{py_prefix}/share/python%{py_ver}
681 %py_incdir              /usr/include/python%{py_ver}
682 %py_sitedir             %{py_libdir}/site-packages
683 %py_sitescriptdir %{py_scriptdir}/site-packages
684 %py_dyndir              %{py_libdir}/lib-dynload
685
686 # pure python modules compilation
687 %py_comp                python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
688
689 %py_ocomp               python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
690
691 # Software written in Python language require Python with main version
692 %pyrequires_eq() Requires:      %1
693
694 # Hardlink binary identical .pyc and .pyo files
695 # (idea by glen <at> pld-linux <dot> org)
696 %__spec_install_post_py_hardlink {\
697 %{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
698 [ ! -d "$RPM_BUILD_ROOT" ] || find "$RPM_BUILD_ROOT" -name '*.pyc' | while read a; do \
699         b="${a%.pyc}.pyo"; \
700         if cmp -s "$a" "$b"; then \
701                 ln -f "$a" "$b"; \
702         fi; \
703 done \
704 }; __spec_install_post_py_hardlink } }
705
706 # remove python sources, so that check-files won't complain
707 # (idea by glen <at> pld-linux <dot> org)
708 %py_postclean() \
709 for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
710  [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
711 done \
712 %{nil}
713
714 # depmod macro
715 %depmod() { \
716 umask 022; \
717 if [ -e /boot/System.map-%1 ]; then \
718         /sbin/depmod -a -F /boot/System.map-%1 %1; \
719 else \
720         if [ -e /boot/System.map ]; then \
721                 /sbin/depmod -a -F /boot/System.map %1; \
722         else \
723                 /sbin/depmod -a %1; \
724         fi \
725 fi; \
726 }
727
728 # XMMS specific macros
729 %xmms_prefix                    %(xmms-config --prefix 2>/dev/null)
730 %xmms_exec_prefix               %(xmms-config --exec-prefix 2>/dev/null)
731 %xmms_version                   %(xmms-config --version 2>/dev/null)
732 %xmms_datadir                   %(xmms-config --data-dir 2>/dev/null)
733 %xmms_plugindir                 %(xmms-config --plugin-dir 2>/dev/null)
734 %xmms_visualization_plugindir   %(xmms-config --visualization-plugin-dir 2>/dev/null)
735 %xmms_input_plugindir           %(xmms-config --input-plugin-dir 2>/dev/null)
736 %xmms_output_plugindir          %(xmms-config --output-plugin-dir 2>/dev/null)
737 %xmms_effect_plugindir          %(xmms-config --effect-plugin-dir 2>/dev/null)
738 %xmms_general_plugindir         %(xmms-config --general-plugin-dir 2>/dev/null)
739
740 %_target_base_arch      %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/')
741
742 # user/group checking macros
743 #
744 # Usage:
745 #       %userremove myuser
746 #
747 %userremove     /usr/lib/rpm/user_group.sh user del
748 %groupremove    /usr/lib/rpm/user_group.sh group del
749 #
750 # Usage:
751 #       if %usertestrm myuser; then
752 #               /usr/sbin/userdel -r myuser
753 # Note:
754 #       use these macros only if you need to call userdel/groupdel with
755 #       a non-standard option or take an extra action; otherwise use the
756 #       %userremove/%groupremove macros
757 #
758 %usertestrm     /usr/lib/rpm/user_group.sh user testrm
759 %grouptestrm    /usr/lib/rpm/user_group.sh group testrm
760 # user group membership management macros
761 #
762 # Usage:
763 #       %addusertogroup myuser agroup
764 #
765 %addusertogroup /usr/lib/rpm/user_group.sh user addtogroup
766
767 # banner support (useful in {pre,post}{,un} and triggers)
768 #
769 # Usage:
770 #       %banner name [-a] [-e] [-n] [-tn] <<EOF
771 # the banner text, the banner text
772 # the banner text, and following line
773 #EOF
774 # You can use any form of here-document, <<'EOF' <<-EOT will do.
775 # NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
776 #
777 # -a   - append to the banner
778 # -e   - send to stderr instead of stdout
779 # -n   - no show banner (overrides -t)
780 # -t   - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
781 #
782 # Tests:
783 # (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
784 # rpm -E 'date | %banner -e banner' > m; sh -x m
785 #
786 %banner(aent:) ( \
787 RPM_SCRIPTVERBOSITY=5 \
788 [ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
789 if [ -x /usr/bin/banner.sh ]; then \
790         CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
791 else \
792         CMD="cat%{-e: >&2}" \
793 fi \
794 eval $CMD %{?2:%2}%{?3: %3}) \
795 %{nil}
796
797 # useradd/groupadd macros
798 # Author: Elan Ruusamäe <glen@pld-linux.org>
799 #
800 # Usage:
801 #   %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
802 #   [-g initial_group] [-G group[,...]] login
803 #
804 #  -u uid. REQUIRED
805 #  -g gid/group. REQUIRED
806 #  -s defaults to /bin/false
807 #  -d defaults to /usr/share/empty
808 #  -c No default
809 #  -r is accepted but ignored (it's always set)
810 #  -k skeleton dir. defaults to /usr/share/empty
811 # rpm specific flags
812 #  -P package name. defaults to %{name}
813 #
814 %useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
815 %{!-u:%{error:useradd: Required argument -u missing}} \
816 %{!-g:%{error:useradd: Required argument -g missing}} \
817 %{!?1:%{error:useradd: Required parameter login missing}} \
818 if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
819         if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
820                 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
821                 exit 1 \
822         fi \
823 else \
824         echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
825         /usr/sbin/useradd \\\
826                 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
827                 -u %{-u*} \\\
828                 -r \\\
829                 -d %{-d*}%{!-d:/usr/share/empty} \\\
830                 -s %{-s*}%{!-s:/bin/false} \\\
831                 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
832                 -g %{-g*} \\\
833                 %{-M} \\\
834                 %{-G:-G %{-G*}} \\\
835                 %{expand:%{%{#}}} 1>&2 || exit $? \
836         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
837 fi;
838
839 # Usage:
840 #   %groupadd [-P package] [-g gid] group
841 #
842 # -g gid. REQUIRED
843 #
844 # Sample:
845 #   %groupadd -P %{name}-base -g %{gid} %{name}
846
847 %groupadd(g:P:rfo)      \
848 %{!-g:%{error:groupadd: Required argument -g missing}} \
849 %{!?1:%{error:groupadd: Required parameter group missing}} \
850 if [ -n "`/usr/bin/getgid %{1}`" ]; then \
851         if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
852                 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
853                 exit 1 \
854         fi \
855 else \
856         echo "Adding group %{1} GID=%{-g*}." \
857         /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
858         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
859 fi;
860
861 # webapp macros
862 # Author: Elan Ruusamäe <glen@pld-linux.org>
863 #
864 # The config is installed/removed inside trigger, this means that you can any
865 # time install apache1/apache/lighttpd package and the configuration file is
866 # updated. if you don't need the config for various reason for specific
867 # webserver, just remove the symlink from config directory using webapp
868 # program. the trigger will not recreate the symlink on upgrades. In other
869 # words the config is linked to webserver config directory on first install of
870 # PACKAGE or WEBSERVER.
871 #
872 # Add package's webserver config to webserver webapps dir.
873 # Usage:
874 #   %webapp_register WEBSERVER WEBAPP
875 #
876 %webapp_register() \
877 %{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
878 if [ "$1" = "1" ] && [ "$2" = "1" ]; then\
879         /usr/sbin/webapp register %1 %2\
880 fi\
881 # reload webserver if the config symlink is there and skip reload if webserver is upgraded\
882 if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
883         %{expand:%service -q %%1 reload}\
884 fi\
885 %{nil}
886
887 # Remove package's config from webserver webapps dir.
888 # Usage:
889 #   %webapp_register [-f] WEBSERVER WEBAPP
890 %webapp_unregister(f) \
891 %{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
892 # remove link if either of the packages are gone \
893 if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
894         /usr/sbin/webapp unregister %1 %2\
895         %{expand:%service -q %%1 reload}\
896 fi \
897 %{nil}
898
899 # service macro.
900 # Author: Elan Ruusamäe <glen@pld-linux.org>
901 #
902 # calls usual service restart on package %post, but skips the restart if
903 # administrator has disabled automatic service restarts in either global
904 # /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
905 #
906 # Usage:
907 #   %service [-q] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
908 #
909 #  -q be silent when service isn't started (for scriplets restaring other package's services)
910 #
911 %service(q) {{%(export quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
912
913
914 # Java macros. based on jpackage macros.java
915 #
916 # Root directory where all Java VMs/SDK/JREs are installed.
917 %_jvmdir                %{_libdir}/jvm
918
919 # Root directory where all Java VMs/SDK/JREs expose their jars
920 %_jvmjardir             %{_libdir}/jvm-exports
921
922 # Root directory for all Java VM/SDK/JRE's private things.
923 %_jvmprivdir    %{_libdir}/jvm-private
924
925 # Root directory for all architecture dependent parts of Java VM/SDK/JRE's
926 %_jvmlibdir             %{_libdir}/jvm
927
928 # Root directory for all architecture independent parts of Java VM/SDK/JRE's
929 %_jvmdatadir    %{_datadir}/jvm
930
931 # Root directory for all configurations parts of Java VM/SDK/JRE's
932 %_jvmsysconfdir %{_sysconfdir}/jvm
933
934 # Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
935 %_jvmcommonlibdir       %{_libdir}/jvm-common
936
937 # Root directory for all common architecture independent parts of Java VM/SDK/JRE's
938 %_jvmcommondatadir      %{_datadir}/jvm-common
939
940 # Root directory for all common configurations parts of Java VM/SDK/JRE's
941 %_jvmcommonsysconfdir   %{_sysconfdir}/jvm-common
942
943 # Directory where arch-specific (JNI) version-independent jars are installed.
944 %_jnidir                %{_libdir}/java
945
946 %java_home              %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm; echo ${JAVA_HOME:-ERROR})
947
948 %ant                    JAVA_HOME=%{java_home} ant
949 %jar                    %{java_home}/bin/jar
950 %java                   %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd; echo $JAVACMD)
951 %javac                  %{java_home}/bin/javac
952 %javadoc                %{java_home}/bin/javadoc
953
954 %add_jvm_extension      JAVA_LIBDIR=%{buildroot}/%{_javadir}    %{_bindir}/jvmjar -l
955
956 %jpackage_script() \
957 install -d $RPM_BUILD_ROOT%{_bindir}\
958 cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
959 #!/bin/sh\
960 #\
961 # %{name} script\
962 # JPackage Project <http://www.jpackage.org/>\
963 \
964 # Source functions library\
965 . %{_javadir}-utils/java-functions\
966 \
967 # Source system prefs\
968 if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
969     . %{_sysconfdir}/java/%{name}.conf\
970 fi\
971 \
972 # Source user prefs\
973 if [ -f $HOME/.%{name}rc ]; then\
974     . $HOME/.%{name}rc\
975 fi\
976 \
977 # Configuration\
978 MAIN_CLASS=%1\
979 BASE_FLAGS=%2\
980 BASE_OPTIONS=%3\
981 BASE_JARS="%(echo %4 | tr ':' ' ')"\
982 \
983 # Set parameters\
984 set_jvm\
985 set_classpath $BASE_JARS\
986 set_flags $BASE_FLAGS\
987 set_options $BASE_OPTIONS\
988 \
989 # Let's start\
990 run "$@"\
991 EOF
992
993 # jpackage 1.7
994 # Directory for maven depmaps
995 #
996 %_mavendepmapdir /etc/maven
997 %_mavendepmapfragdir /etc/maven/fragments
998
999 #
1000 # add_to_depmap adds an entry to the depmap. The arguments are:
1001 #
1002 # %1 the original groupid
1003 # %2 the original artifact id
1004 # %3 the version
1005 # %4 the new groupid
1006 # %5 the new artifactid
1007 #
1008
1009 %add_to_maven_depmap() \
1010 install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1011 cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1012 <dependency>\
1013     <maven>\
1014         <groupId>%1</groupId>\
1015         <artifactId>%2</artifactId>\
1016         <version>%3</version>\
1017     </maven>\
1018     <jpp>\
1019         <groupId>%4</groupId>\
1020         <artifactId>%5</artifactId>\
1021         <version>%3</version>\
1022     </jpp>\
1023 </dependency>\
1024 \
1025 EOF\
1026 %{nil}
1027
1028 #==============================================================================
1029 #
1030 # update_maven_depmap updates the main maven depmap
1031 #
1032 %update_maven_depmap() \
1033 echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1034 if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1035 cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1036 fi\
1037 echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1038
1039
1040 # PEAR install macros
1041 # Author: Elan Ruusamäe <glen@pld-linux.org>
1042 #
1043 # Usage:
1044 #       %%pear_package_setup [-a #] [-n FMT]
1045 #
1046 # -a #   - also unpack SOURCE#. for PEAR bootstrapping
1047 # -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
1048 # -z     - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
1049 #
1050 # unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1051 # destination hierarchy. you should copy the tree to buildroot after
1052 # patching/reorganizing with %%pear_package_install.
1053 #
1054 # additionally BUILDROOT is stripped from files and files are converted to UNIX
1055 # line endings.
1056 #
1057 # the pear install process output is recorded to install.log, you should put it
1058 # to %%doc for later debug or just for information.
1059 #
1060 # additionally additional-packages.txt is produced if it was detected that the
1061 # package has optional dependencies. the file format is suitable of displaying
1062 # in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1063 # automatically added for this file.
1064
1065
1066 # records install.log and transforms PEAR names to PLD Linux rpm package names.
1067 %__pear_install_log \
1068 tee install.log \
1069 # make post message of optional packages \
1070 grep 'can optionally use' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,' > optional-packages.txt \
1071 if [ -s optional-packages.txt ]; then \
1072         awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1073 else \
1074         rm -f optional-packages.txt \
1075 fi \
1076 %{nil}
1077
1078 # command invoking pear cli
1079 %__pear /usr/bin/pear
1080
1081 %pear_install(a:n:zD) \
1082 %__pear \\\
1083         -c pearrc \\\
1084         -d doc_dir=/docs \\\
1085         -d php_dir=%{php_pear_dir} \\\
1086         -d bin_dir=%{_bindir} \\\
1087         -d data_dir=%{php_pear_dir}/data \\\
1088         -d test_dir=%{php_pear_dir}/tests \\\
1089         install \\\
1090         --packagingroot=%{builddir} \\\
1091         --offline \\\
1092         --nodeps \\\
1093         %{-f:--force} \\\
1094         %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
1095 %{nil}
1096
1097 # The main macro.
1098 # using this macro will append optional-packages.txt to the nocompressdoc list
1099 # as it's displayed to user after package install. and adding additional gzip
1100 # dep is just waste ;)
1101 %pear_package_setup(a:n:zD) \
1102 %define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1103 %define builddir %{_builddir}/%{srcdir} \
1104 %setup -q -c -T %{-D:-D} -n %{srcdir} \
1105 %{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
1106 %{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
1107 %pear_install \
1108 %{-z:cd ..} \
1109 cat %{-z:$_N/}.install.log | %__pear_install_log \
1110 \
1111 # undos sources \
1112 find . -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
1113 %{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1114 %{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1115 %{nil}
1116
1117 # Copies exctracted PEAR package structure and PEAR registry to buildroot.
1118 # Author: Elan Ruusamäe <glen@pld-linux.org>
1119 %pear_package_install() \
1120 cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1121 find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1122 # help the developer out a little: \
1123 if [ -f _noautoreq ]; then \
1124         echo "AutoReqdep detected:" \
1125         echo "_noautoreq $(cat _noautoreq)" \
1126 fi \
1127 %{nil}
1128
1129
1130 # Register OpenLDAP schema.
1131 # Author: Elan Ruusamäe <glen@pld-linux.org>
1132 #
1133 # Usage:
1134 #   %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1135 #
1136 #  -d specify dependant schemas, separated by comma
1137 #
1138 %openldap_schema_register(d:) \
1139 for schema in %*; do \
1140         if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1141                 %{__sed} -i -e " \
1142                         /^include.*local.schema/{ \
1143                                 iinclude\\t     $schema\
1144                         } \
1145                 " /etc/openldap/slapd.conf \
1146         fi \
1147 done \
1148 # enable dependant schemas \
1149 if [ "%{-d*}" ]; then \
1150         %{__sed} -i -e ' \
1151         /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1152                 s/^#// \
1153         }' /etc/openldap/slapd.conf \
1154 fi \
1155 %{nil}
1156
1157 # Unregister OpenLDAP schema.
1158 # Author: Elan Ruusamäe <glen@pld-linux.org>
1159 #
1160 # Usage:
1161 #   %%openldap_schema_unregister %{schemadir}/horde.schema
1162 #
1163 %openldap_schema_unregister() \
1164 for schema in %*; do \
1165         if grep -q "$schema" /etc/openldap/slapd.conf; then \
1166                 %{__sed} -i -e " \
1167                 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1168                 # for symmetry it would be nice if we disable enabled schemas in post, \
1169                 # but we really can not do that, it would break something else. \
1170                 " /etc/openldap/slapd.conf \
1171         fi \
1172 done \
1173 %{nil}
1174
1175 %env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
1176
1177
1178 # Build modules for kernels 2.6
1179 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1180 #
1181 # Usage:
1182 #       %build_kernel_modules -m <modules> -C <directory>
1183 #
1184 #  remember that proper Makefile is still required
1185 # Options:
1186 #  -m <modules> (required) -- comma-separated list of modules to save,
1187 #               without .ko extension, may be placed in subdirectory
1188 #  -C <directory> -- change to <directory> before doing anything
1189 #  -p <arg>, -P <arg> -- arguments passeed to make scripts
1190 #  -c -- do not execute make clean
1191 #  <additional arguments> -- all additional arguments will be passed to
1192 #               make modules
1193 #
1194 # Additional patching supported via here document. Try:
1195 #       %build_kernel_modules -m module <<'EOF'
1196 #       your patch script here
1197 #       EOF
1198 # Don't use it unless patching depends on config options.
1199
1200 # Developer note: don't touch it unless you know how to handle '\'.
1201 # - \ in script expands to nothing
1202 # - \\\ in script expands to \
1203 # - \\\ inside definition expands to nothing
1204 # - \\\\\\\ inside definition expands to \
1205 # - in last line \ has to touch arguments so arguments passing
1206 #   in new lines (using \) will be supported
1207
1208 %build_kernel_modules(p:P:m:C:c)                                                                        \
1209 %{!?-m:%{error:%{0}: Required module name/list missing} exit 1}         \
1210                                                                                                                                         \
1211 %define Opts                                                                                                            \\\\\\\
1212 %if "%{_target_base_arch}" != "%{_arch}"                                                        \\\
1213         %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386"  \\\
1214         CC="%{__cc}" CPP="%{__cpp}" ARCH=%{_target_base_arch}                   \\\
1215         %else                                                                                                                   \\\
1216         ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1217         %endif                                                                                                                  \\\
1218 %else                                                                                                                           \\\
1219         CC="%{__cc}" CPP="%{__cpp}"                                                                             \\\
1220 %endif                                                                                                                          \
1221 %define MakeOpts HOSTCC="%{__cc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
1222                 O=$PWD/o %{?with_verbose:V=1} %{Opts}                                           \
1223                                                                                                                                         \
1224 %{?-C:cd %{-C*}}                                                                                                        \
1225 compile() {                                                                                                                     \
1226         L="<"; [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)"    \
1227         set -e -x                                                                                                               \
1228         local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1229                                                                                                                                         \
1230 for cfg in ${cfgs:-dist}; do                                        \
1231         [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1                                 \
1232                                                                                                                                         \
1233         rm -rf o                                                                                                                \
1234         install -d o/include/linux                                                                              \
1235         ln -sf %{_kernelsrcdir}/config-$cfg o/.config                                   \
1236         ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers    \
1237         ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1238                                                                                                                                         \
1239         set +x                                                                                                                  \
1240         [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell    \
1241         set -x                                                                                                                  \
1242                                                                                                                                         \
1243         %if %{with dist_kernel}                                                                                 \
1244                 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts                       \\\
1245                         %{-p*} %{-P*}                                                                                   \\\
1246                         %{MakeOpts}                                                                                             \
1247         %else                                                                                                                   \
1248                 install -d o/include/config                                                                     \
1249                 touch o/include/config/MARKER                                                           \
1250                 ln -sf %{_kernelsrcdir}/scripts o/scripts                                       \
1251         %endif                                                                                                                  \
1252                                                                                                                                         \
1253         %{!?-c:%{__make} -C %{_kernelsrcdir} clean                                              \\\
1254                 RCS_FIND_IGNORE="-name '*.ko' -o"                                                       \\\
1255                 M=$PWD %{MakeOpts}}                                                                                     \
1256         %{__make} -C %{_kernelsrcdir} modules                                                   \\\
1257                 ${1+"$@"}                                                                                                       \\\
1258                 M=$PWD %{MakeOpts}                                                                                      \
1259                                                                                                                                         \
1260         for MODULE in {%{-m*},}; do                                                                             \
1261                 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko                           \
1262         done                                                                                                                    \
1263 done                                                                                                                            \
1264 %{?-C:cd -}                                                                                                                     \
1265 }                                                                                                                                       \
1266 compile %{*}\
1267 %{nil}
1268
1269
1270 # Install kernel modules built by %build_kernel_modules
1271 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1272 #
1273 # Usage:
1274 #       %install_kernel_modules -m <modules> -d <directory>
1275 #
1276 # Options:
1277 #  -m <modules> (required) -- comma-separated list of modules to install,
1278 #               without .ko extension, may be placed in subdirectory
1279 #  -d <directory> (required) -- in what subdirectory modules should be
1280 #               installed (eg. misc, kernel/drivers/net)
1281 #  -s <suffix> -- suffix to use when installing modules, useful when module
1282 #               with same name exists in kernel already
1283 #  -n <file> -- name of modprobe config file to use (without .conf extension)
1284 #               for defining aliases, only useful with -s
1285
1286 %install_kernel_modules(m:d:s:n:)                                                                       \
1287 %{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1}          \
1288 %{!?-d:%{error:%{0}: Required module directory missing}exit 1}          \
1289 %{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1290                                                                                                                                         \
1291 %define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver}                      \
1292 %define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
1293                                                                                                                                         \
1294 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1295                                                                                                                                         \
1296 for MODULE in {%{-m*},}; do                                                                                     \
1297         [ -n "${MODULE}" ] || continue                                                                  \
1298         for cfg in ${cfgs:-dist}; do                                    \
1299                 [ "$cfg" = smp ] && suf=smp || suf=                                                     \
1300                 MNAME=${MODULE##*/}                                                                                     \
1301                 install -D ${MODULE}-$cfg.ko                                                            \\\
1302                         %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko                  \
1303                 %{?-s:install -d %{ModprobeD}$suf                                                       \
1304                         echo "alias ${MNAME} ${MNAME}-%{-s*}"                                   \\\
1305                         >> %{ModprobeD}$suf/%{-n*}.conf}                                                \
1306         done                                                                                                                    \
1307 done                                                                                                                            \
1308 %{nil}
1309
1310 # patchset macros
1311 # Author: Elan Ruusamäe <glen@pld-linux.org>
1312 #
1313 # Usage:
1314 #   %patchset_source -f <seq(1) format> <start> [<end>]
1315 #   %patchset_patch <start> [<end>]
1316 #
1317 # If <end> is omited, it is assumed to be <start>.
1318 #
1319 # For example in preamble:
1320 #  %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1321 # and in %prep:
1322 #  %patchset_patch 33 44
1323
1324 # generate SourceX urls from range START STOP
1325 # Format can be SINGLE format char of %e, %f, %g, see seq(1)
1326 # The sources start from 10000
1327 %patchset_source(f:b:) %(
1328         base=%{-b*}%{!-b*:10000};
1329         start=$(expr $base + %1);
1330         end=$(expr $base + %{?2}%{!?2:%{1}});
1331         # we need to call seq twice as it doesn't allow two formats
1332         seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1333         seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1334         paste %{tmpdir}/__ps{1,2};
1335         rm -f %{tmpdir}/__ps{1,2};
1336 ) \
1337 %{nil}
1338
1339 # apply sources from %patchset_source
1340 # -p specify -pX for %patch line
1341 # -b base offset: defaults to 10000
1342 %patchset_patch(f:p:b:) %(
1343         base=%{-b*}%{!-b*:10000};
1344         start=$(expr $base + %1);
1345         end=$(expr $base + %{?2}%{!?2:%{1}});
1346         echo ": patchset_patch %1%{?2: to %2}";
1347         seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
1348 ) \
1349 %{nil}
1350
1351 # browser plugins v2
1352 # Author: Elan Ruusamäe <glen@pld-linux.org>
1353 #
1354 # Usage:
1355 #       %browser_plugins_add_browser <name> -p <plugindir>
1356 #
1357 #  <name> (required) -- name of the browser. usually %{name}.
1358 #  -p <plugindir> (required) -- in what directory browser searches for its plugins.
1359 #  -b -- default blacklists
1360 #  -a <arch> override arch
1361 #
1362 # Example:
1363 #   %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1364
1365 %_browserpluginsconfdir         /etc/browser-plugins
1366 %_browserpluginsdir                     %{_libdir}/browser-plugins
1367 %update_browser_plugins         /usr/sbin/update-browser-plugins || :
1368
1369 %browser_plugins_add_browser(p:b:a:) \
1370         browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
1371         install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
1372         ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1373         blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
1374         echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1375         %{-b:cat >> $blacklist_file %{-b*}} \
1376 %{nil}
1377
1378 # vim:ts=4 sw=4 noet syn=spec
This page took 0.137146 seconds and 4 git commands to generate.